CHEFFILT - Editorial
#PROBLEM LINK:
[Contest][222]
**Author:** [][4444]
**Tester:** [][5555]
**Editorialist:** [Kevin Atienza][6666]
#PREREQUISITES:
Dynamic programming
#PROBLEM:
Chef has an image $S$ consisting of just $10$ pixels in a row. Each pixel is either black or white. There are $N$ filters, where each filter is a string of length $10$ consisting of `+` and `-` characters. If a particular filter is applied, then all pixels corresponding to `+`s in the filter will get *flipped*.
How many different subsets of the filters will cause the image to become an all-black image?
#QUICK EXPLANATION:
We can replace images and filters with binary numbers of at most $|S|$ bits, where "white" and `+` correspond to $1$. In this representation, there are $2^{|S|}$ distinct filters and $2^{|S|}$ distinct images, $0 \ldots 2^{|S|}-1$, and applying a filter means simply performing a bitwise-XOR with the filter on the image.
Let $c(i)$ be the number of filters $i$ present in the input. Define $f(i,j)$ be the number of ways to turn the image $j$ into an all-black image (i.e. image $0$) using only the first $i+1$ distinct kinds of filters. The following is a recurrence for $f(i,j)$): $f(i,j)$:
$$f(i,j) = \begin{cases}
[j = 0] & \text{if $i = -1$} \\\
f(i-1,j) & \text{if $i > -1$ and $c(i) = 0$} \\\
\left[f(i-1,j) + f(i-1,j\oplus i)\right]2^{c(i)-1} & \text{if $i > -1$ and $c(i) > 0$}
\end{cases}$$
Note that the The answer is simply $f(2^{|S|}-1, S)$. (where $|S|$ is not the absolute value, rather it is the length of the original input string. In this problem this value is always $10$.)
Since there are around $4^{|S|} \le 1.05\times 10^6$ possible arguments to $f$, we can *tabulate* $f(i,j)$. If the entries of this table is filled in order of increasing $i$, then we'll be able to compute all entries in just $O(4^{|S|})$ time.
#EXPLANATION:
The problem can be stated in terms of binary strings. An "image" and a "filter" is really just a binary string of length $10$. So let's say we replace "white" and "`+`" with $1$, and "black" and "`-`" with "0". Then:
- The initial image $S$ can be represented as an integer from $0$ to $2^{10}-1$.
- The all-black image is simply image $0$.
- A filter $F$ can be represented as an integer from $0$ to $2^{10}-1$.
- The result of applying the filter $F$ to $S$ is simply the [bitwise XOR](https://en.wikipedia.org/wiki/Bitwise_operation#XOR) of $F$ and $S$, denoted $F\oplus S$. This is clear from the problem and from the definition of bitwise XOR. (see the appendix for a refresher on bitwise XOR)
The problem is now:
*Given **Given an integer $S$ and a set of $N$ filters (represented by integers), how many subsets are there such that applying the bitwise-XOR of each number to $S$ results in image $0$.* $0$?**
Note that filters are considered distinct even if they are represented by the same integer.
Subsets with bitwise XOR zero
====
We restate the problem slightly as follows: We have an integer $S$ and a bunch of integers called *filters*, and we want to count how many ways there are to select a subset of the filters so that the bitwise XOR of all these numbers together with $S$ is zero. (Note that bitwise XOR is associative, so this is an equivalent formulation.)
Now, $N$ can be very large, especially in the last subtask, so this seems intractable. However, notice that while $N$ can reach up to $10^5$, the number of *distinct* filters is at most $2^{10}$. This suggests grouping the filters according to the operations they do, lumping filters doing the same operation together in their own groups. Notice that this reordering/grouping doesn't affect the answer, because order doesn't matter in subsets. (And indeed, because bitwise XOR is commutative and associative.)
So now, instead of our $N$ filters, we can replace it with a list $c_0, c_1, c_2 \ldots c_{2^{10}-1}$, where $c_i$ is the number of filters that are represented by the integer $i$.
Now, what happens if we apply a set of filters represented by the same integer, say, $i$? Well, after applying the first one, the image becomes $S\oplus i$. Then after applying the second one, it becomes the value $S\oplus i\oplus i$. But this is just equal to $S$! In other words, applying two equivalent filters is the same as applying none at all. Hmm, okay, Okay, let's proceed. After applying third one, the number becomes $S\oplus i$ again, which is the same as applying only once! We can continue with this for more and more filters to get the following fact:
*Applying an odd number of equivalent filters is the same as applying just one equivalent filter. Applying an even number of equivalent filters is the same as applying none.*
This makes things much easier. Suppose we look at a particular filter, say $i$. Then there are only two possible outcomes when applying any number of such filters to $S$: $S$ and $S\oplus i$. Also, applying every even subset of our set of filters results in $S$, and applying every odd subset results in $S\oplus i$. Thus, we just need to know how many subsets are odd and even.
Suppose we have there are $c_i$ filters. How many subsets are there? For each element, there are two choices, whether to include it or not, so there are $\underbrace{2\cdot 2\cdots 2}_{c_1}$ or [$2^{c_i}$ subsets](http://mathworld.wolfram.com/Subset.html). How many of those are even? Well, similarly as above, we can choose, for each element, whether to include it or not. Thus, there are again two choices for each element. However, the last element is special! This is because we want to ensure that the size of the set is even. So in selecting the last element, we first check whether the size of the current set being constructed is even or odd. If it is odd, then we have no choice but to *include* the last element to the set to make it even. If it is even, then we have no choice but to *exclude* the last element, otherwise it will be odd. Therefore, after making the choices for the first $c_i - 1$ elements, there is a unique choice on what to do for the last element. This implies that the number of even-sized subsets is equal to $2^{c_i-1}$! A very similar argument shows that there are also $2^{c_i-1}$ odd-sized subsets.
Note that the argument above only holds for $c_i$ is not $0$. But the case $c_i = 0$ is trivial: there is only one such set, namely the empty set, and it is even.
Armed with this, we can now devise a dynamic programming solution for the problem. Let's define $f(i,j)$ as the number of ways to turn the image $j$ into image $0$ using only the first $i+1$ distinct kinds of filters. Note that the answer is simply $f(2^{10}-1, S)$.
To compute $f(i,j)$, consider the filters represented by $i$. There are $c_i$ such filters. There are $2^{c_i-1}$ even-sized subsets, and when every such set of filters is applied, the resulting image is $i$. There are $2^{c_i-1}$ odd-sized subsets, and when every such set of filters is applied, the resulting image is $i\oplus j$. Therefore, we have the following general recurrence:
$$f(i,j) = \left[f(i-1,j) + f(i-1,j\oplus i)\right]2^{c_i-1}$$
Note that this only works when $i \ge 0$ and $c_i > 0$. If $c_i = 0$, then there are no filters $i$ so we can simply say $f(i,j) = f(i-1,j)$. Finally, if $i < 0$, then there are no filters to apply altogether, and the only way to turn $j$ into zero is if $j$ is already zero! Thus, we have: $f(-1,0) = 1$ and $f(-1,j) = 0$ for $j \not= 0$.
Summarizing these formulas, we now have the following:
$$f(i,j) = \begin{cases}
[j = 0] & \text{if $i = -1$} \\\
f(i-1,j) & \text{if $i \ge 0$ and $c_i = 0$} \\\
\left[f(i-1,j) + f(i-1,j\oplus i)\right]2^{c_i-1} & \text{if $i \ge 0$ and $c_i > 0$}
\end{cases}$$
where the (The expression "$[j = 0]$" uses the [Iverson bracket](https://en.wikipedia.org/wiki/Iverson_bracket) notation.
notation.)
Since there are around $4^{10} \le 1.05\times 10^6$ possible *distinct* arguments to $f$, we can *tabulate* $f(i,j)$, and populate this table in increasing order of $i$. Filling a table of up to $10^6$ elements easily passes the time limit, even in Python!
Appendix: bitwise XOR
====
It's helpful to refresh oneself about the bitwise XOR operation. The bitwise XOR of two numbers is obtained by writing two numbers in binary, padding with leading zeroes if necessary so they have the same number of digits, and "XOR"-ing each column. The resulting binary number is the bitwise XOR. (Remember that the XOR of two bits is $1$ if they are different, and $0$ if they are the same.)
For example, the bitwise XOR of $143=10001111_2$ and $202=11001010_2$ can be obtained as:
$$\begin{matrix}
& 10001111 \\
\oplus & 11001010 \\
\hline & 01000101
\end{matrix}$$
Thus, $143\oplus 202=01000101_2=69$.
Based on this definition, the bitwise XOR has the following properties (straightforward to prove):
$$\begin{align*}
a\oplus b &\equiv b\oplus a && \text{commutativity law} \\\
(a\oplus b)\oplus c &\equiv a\oplus (b\oplus c) && \text{associativity law} \\\
a\oplus 0 &\equiv a && \text{identity law} \\\
a\oplus a &\equiv 0 && \text{inverse law}
\end{align*}$$
(we invite you to derive these properties yourself)
<br>
Notice that addition and multiplication follow similar rules. The XOR-identity element is $0$ (just like in addition, while in multiplication it is $1$). However, interestingly, the *XOR-inverse of every number is itself*! (whereas in addition, this is only true for $0$, and in multiplication this is only true for $1$ and $-1$)
<br>
From these properties, we can also prove the following:
$$a = b \Longleftrightarrow a\oplus c = b\oplus c$$
We can call this the *cancellation law*.
<br>
The forward direction ($a = b \Longrightarrow a\oplus c = b\oplus c$) is trivial. To prove the backward direction, let's assume that $a\oplus c = b\oplus c$. Then:
$$\begin{align*}
a\oplus c &= b\oplus c && \text{} \\\
(a\oplus c)\oplus c &= (b\oplus c)\oplus c && \text{} \\\
a\oplus (c\oplus c) &= b\oplus (c\oplus c) && \text{Associativity law} \\\
a\oplus 0 &= b\oplus 0 && \text{Inverse law} \\\
a &= b && \text{Identity law}
\end{align*}$$
which is what we wanted to prove.
#Time Complexity:
$O(4^{|S|})$
#AUTHOR'S AND TESTER'S SOLUTIONS:
[setter][333]
[tester][444]
[222]: http://www.codechef.com/DEC15/problems/CHEFFILT
[333]: The link is provided by admins after the contest ends and the solutions are uploaded on the CodeChef Server.
[444]: The link is provided by admins after the contest ends and the solutions are uploaded on the CodeChef Server.
[4444]: http://www.codechef.com/users/????
[5555]: http://www.codechef.com/users/????
[6666]: http://www.codechef.com/users/kevinsogo